// Analizator.cs - Klasa statistikog analizatora.

namespace Statistika {
  public class Analizator {

    // Dogaaj "napravljen je nov uzorak"
    // koji je tipa navedenog delegata.
    public event Rukovalac NovUzorak;

    public void Radi(ISlucajan sluc, int n) {  // Rad analizatora.
      for (int i=0; i<n; i++) {
        double broj = sluc.SlucBroj();

        // Dojava dogaaja registrovanim oslukivaima
        // pozivanjem metoda u njihovim delegatima
        // (null - nije registrovan nijedan oslukiva).
        if (NovUzorak != null) NovUzorak(broj);
      }
    }
  }
}
