// Casovnik2.cs - Klasa aktivnih asovnika.

namespace Uredjivanje {
  using System.Threading;

  public class Casovnik {
    private int dt;                        // Interval ispisivanja.
    private char zn;                       // Ispisivani znak.
    private Thread nit;                    // Nit koja radi.
    private bool radi = false;             // Da li treba da radi?
    private bool kraj = false;             // Da li treba da se zavri?

    public Casovnik(int dt, char zn) {     // Inicijalizacija.
      this.dt = dt; this.zn = zn;
      (nit = new Thread(akcija)).Start();
    }

    private void akcija() {                // Sadraj niti.
      try {
        while (!kraj) {
          lock (this) { if (!radi) Monitor.Wait(this); }
          Thread.Sleep(dt);
          System.Console.Write(zn);
        }
      } catch (ThreadInterruptedException) {}
    }

    public void Stani() { radi = false; }  // Privremeno zaustavljanje.

    public void Kreni() {                  // Nastavak rada.
      lock (this) { radi = true; Monitor.Pulse(this); }
    }

    public void Zavrsi()                   // Zavretak niti.
      { kraj = true; nit.Interrupt(); }
  }
}
