// CeoBroj.cs - Klasa celih brojeva.

namespace Aritmetika {
  public class CeoBroj: INumericko {
    private int i;                              // Vrednost broja.

    public CeoBroj(int ii) { i = ii; }          // Inicijalizacija.

    public object Clone()                       // Kopija broja.
      { return MemberwiseClone(); }

    public INumericko Dodaj(INumericko b) {     // Dodavanje broja.
      if (!(b is CeoBroj)) throw new GreNumTip();
      i += ((CeoBroj)b).i;
      return this;
    }

    public INumericko Proizvod(INumericko b) {  // Proizvod dva broja.
      if (!(b is CeoBroj)) throw new GreNumTip();
      return new CeoBroj(i * ((CeoBroj)b).i);
    }

    public override string ToString()           // Tekstualni opis.
      { return i.ToString(); }
  }
}
