// Devijacija.cs - Klasa standardne devijacije.

namespace Statistika {
  using System;
  public class Devijacija: IPokazatelj  {
    private int n;                        // Broj uzoraka.
    private double s, d;                  // Zbir i zbir kvadrata uzoraka.

    public void Ispocetka() { d = s = n = 0; } // Poetak analize.

    public void Azuriraj(double broj)          // Akumuliranje podataka.
      {  s += broj; d += broj * broj; n++; }

    public double Uzmi                         // Dohvatanje rezultata.
      { get { return n>0 ? Math.Sqrt(d/n-s*s/n/n) : Double.NaN; } }

    public override string ToString()          // Naziv pokazatelja.
      { return "standardna devijacija"; }
  }
}
