// Frima.cs - Klasa firmi.

namespace Prodaja {
  public class Firma {
    private Radnik[] radnici;                     // Niz radnika.
    private double marza;                         // Mara poslovanja.

    public Firma(double m, int kap) {             // Inicijalizacija.
      marza = m;
      radnici = new Radnik [kap];
    }

    public bool Zaposli(Radnik r) {               // Zapoljavanje radnika.
      int i=0; while (i<radnici.Length && radnici[i]!=null) i++;
      if (i == radnici.Length) return false;
      radnici[i] = r;
      return true;
    }

    public bool Otpusti(int i) {                  // Otputanje radnika.
      if (i<0 || i>=radnici.Length || radnici[i]==null)
        return false;
      radnici[i] = null;
      return true;
    }
  
    public double Dobit { get {                   // Dobit firme.
      double ukPrihod = 0, ukPlata = 0;
      for (int i=0; i<radnici.Length; i++)
        if (radnici[i] != null) {
          if (radnici[i] is Prodavac)
            ukPrihod += radnici[i].Prihod;
          ukPlata += radnici[i].Plata;
        }
      return ukPrihod * marza / 100 - ukPlata;
    }}
  
    public override string ToString() {           // Tekstualni opis.
      string s = "";
      for (int i=0; i<radnici.Length; i++)
        if (radnici[i] != null) s += radnici[i] + "\n";
      return s + "Dobit firme: " + Dobit;
    }
  }
}
