// FunkcijeTest.cs - Ispitivanje grafikog prikazivanja funkcija.

using Funkcije;
using System;

class Funkcije1Test {
  static void Main() {

    // Funkcija zadata delegatom koji sadri metodu klase.    
    Poli poli = new Poli(new double []{4,-4,-1,1}); // (x+2)(x-1)(x-2)
    Grafik.Crtaj(new Fun(poli.Vrednost), -3, 3, 61, -3, 7, 11);
    Console.WriteLine();

    // Funkcija zadata metodom klase (implicitna konverzija u delegat).
    Grafik.Crtaj(poli.Izvod, -3, 3, 61, -7, 7, 11);
    Console.WriteLine();
    
    // Funkcija zadata bezimenom metodom.
    Grafik.Crtaj(delegate(double x) { return Math.Sin(x)/x; },
                 0.1, 20, 61, -0.3, 1, 11 );
    Console.WriteLine();
    
    // Funkcija zadata lambda izrazom. 
    Grafik.Crtaj(x=>Math.Exp(-0.1*x)*Math.Sin(x), 0, 20, 61, -1, 1, 11);
    Console.WriteLine();
    
    // Funkcija zadata statikom metodom.
    Grafik.Crtaj(Math.Sin, 0, 20, 61, -1, 1, 11);
  }
}
