// Grafik.cs - Usluna klasa za grafiki prikaz funkcije.

using System;

namespace Funkcije {
  public static class Grafik {
    public static void Crtaj(Fun fun,
        double xmin, double xmax, int sir,
        double ymin, double ymax, int vis) {
      double dx = (xmax - xmin) / (sir - 1); // Promena x-a po koloni.
      double dy = (ymax - ymin) / (vis - 1); // Promena y-a po redu.
      int[] y = new int [sir];               // Vrednosti funkcije.
      for (int i=0; i<sir; i++) 
        y[i] = (int)((fun(xmin + i * dx) - ymin) / dy);
      int yosa = (int)(-xmin / dx);          // Indeks kolne y-ose.
      int xosa = (int)(-ymin / dy);          // Indeks reda x-ose.
      for (int vrs=vis-1; vrs>=0; vrs--) {
        int poz = -1;                // Poslednja popunjena pozicija u redu.
        for (int kol=0; kol<sir; kol++) {
          char zn = ' ';
          if      (y[kol] == vrs) zn = '*';
          else if (vrs==xosa && kol==yosa) zn = '+';
          else if (kol == yosa) zn = '|';
          else if (vrs == xosa) zn = '-';
          if (zn != ' ') {            // Da ne bude razmaka na kraju reda.
            for (int x=0; x<kol-poz-1; x++) Console.Write(" ");
            Console.Write(zn);
            poz = kol;
          }
        }
        Console.WriteLine();
      }
    }
  }
}
