// Grupa.cs - Klasa grupe elektrinih potroaa.

namespace Struja {
  public class Grupa: Potrosac {
    private class Elem {                          // Element liste:
      public Potrosac potr;                       // - sadrani potroa,
      public Elem sled;                           // - sledei element,
      public Elem(Potrosac p) { potr = p; }       // - inicijalizacija.
    }

    private Elem prvi, posl;                      // Poetak i kraj liste.
    private double snaga;                         // Snaga grupe potroaa.
  
    public Grupa Dodaj(Potrosac p) {              // Dodavanje potroaa.
      Elem novi = new Elem(p);
      if (prvi == null) prvi = novi; else posl.sled = novi;
      posl = novi;
      snaga += p.Snaga;
      return this;
    }

    public override double Snaga {get{ return snaga; }} // Snaga grupe potr.
  
    public override string ToString() {                 // Tekstualni opis.
      string s = "[";
      for (Elem tek=prvi; tek!=null; tek=tek.sled) {
        s += tek.potr;
        if (tek.sled != null) s += ",";
      }
      return s + "]";
    }
  }
}
