// Izvestac.cs - Klasa aktivnih izvetaa.

namespace Skladista {
  using System.Threading;
  using System;

  public class Izvestac: IAkter {
    private static int posId = 0;   // Poslednje korieni identifikator.
    private int id = ++posId;       // Identifikator izvetaa.
    private Skladiste skladiste;    // Pridrueno skladite.
    private int perioda;            // Perioda izvestavanja.
    private Thread nit;             // Nit koja radi.
    private bool kraj = false;      // Da li treba da se zavri?

    public Izvestac(Skladiste sklad, int per) { // Inicijalizacija.
      perioda = per; skladiste = sklad;
      nit = new Thread(akcija);
    }
    public Izvestac(Skladiste sklad)
      : this(sklad, 5000) {}
  
    public void Pocni() { nit.Start(); }        // Pokretanje niti.

    private void akcija() {                     // Sadraj niti.
      Console.WriteLine("Izvest " + id + " krenuo");
      try {
        while (!kraj) {
          Thread.Sleep(perioda);
          Console.WriteLine("Izvest " + id + " [" + skladiste + "]");
        }
      } catch (ThreadInterruptedException) {}
      Console.WriteLine("Izvest " + id + " zavrsio");
    }

    public void Zavrsi()                        // Zavretak niti.
      { kraj = true; nit.Interrupt(); }
  }
}
