// Izvor.cs - Klasa izvora elektrine energije.

namespace Struja {
  public class Izvor {
    private Potrosac[] niz;                          // Prikljuna mesta.
    private double snaga, opter;                     // Snaga i optereenje
                                                     //   izvora.
    public Izvor(double s, int k) {                  // Inicijalizacija.
      niz = new Potrosac [k];
      snaga = s;
    }
  
    public double Snaga { get { return snaga; } }    // Snaga izvora.
  
    public double Opterecenje {get{ return opter; }} // Optereenje izvora.
  
    public int BrMesta { get { return niz.Length; }} // Broj mesta.
  
    public bool Prikljuci(Potrosac p, int i) {       // Prikljuivanje
      if (i<0 || i>niz.Length-1) return false;       //   potroaa.
      if (niz[i] != null) {
        opter -= niz[i].Snaga;
        niz[i] = null;
      }
      if (p == null) return true;
      double s = p.Snaga;
      if (opter+s > snaga) return false;
      niz[i] = p; opter += s;
      return true;
    }
 
    public override string ToString() {              // Tekstualni opis.
      string s = opter + "/" + snaga + "\n";
      for (int i=0; i<niz.Length; i++)
        s += i + ": " +
             (niz[i]!=null ? niz[i].ToString() : "<< prazno >>") + "\n";
      return s;
    }
  }
}
