// Krug2.cs - Klasa krugova u ravni koji ne smeju da se preklapaju.

namespace Ravan {
  public class Krug {
    private Tacka c; private double r;  // Centar i poluprenik.
    private Krug pret, sled;            // Prethodni i sledei krug.
    private static Krug prvi = null;    // Statika lista svih krugova.

    private Krug() {}                   // Samo za interne potrebe.
                                        // Moe li krug da postoji?
    public static bool Moze(double r, double x, double y) {
      Krug k = new Krug(); k.r = r; k.c = new Tacka(x, y);
      for (Krug tek=prvi; tek!=null; tek=tek.sled)
        if (tek.Rastojanje(k) < 0) return false;
      return true;
    }
 
    public Krug(double r, double x, double y) {  // Stvaranje kruga.
      if (!Moze(r, x, y)) System.Environment.Exit(1);
      this.r = r;
      this.c = new Tacka(x, y);
      sled = prvi; pret = null;
      if (prvi != null) prvi.pret = this;
      prvi = this;
    }

    public void Brisi() {                        // Krug vie nije potreban.
      if (pret != null) pret.sled = sled;
        else prvi = sled;
      if (sled != null) sled.pret = pret;
    }

    public bool Premesti(double x, double y){    // Premetanje kruga.
      if (!Moze(r, x, y)) return false;
      c.X = x; c.Y = y; return true;
    }

    public bool Pomeri(double dx, double dy){    // Pomeranje kruga.
      if (!Moze(r, c.X+dx, c.Y+dy)) return false;
      c.X += dy; c.Y += dy; return true;
    }

    public double Rastojanje(Krug k)          // Rastojanje do drugog kruga.
      { return c.Rastojanje(k.c) - r - k.r; }

    public override string ToString()         // Tekstualni opis.
      { return "K[" + r + ",(" + c.X + "," + c.Y + ")]"; }
  }
}
