// Lista1a.cs - Klasa listi celih brojeva (iterativno).

class Lista1a {
  private class Elem {                // Element liste:
    public int broj;                  // - sadraj,
    public Elem sled;                 // - sledei element,
    public Elem(int b, Elem s=null)   // - inicijalizacija.
      { broj = b; sled = s; }
  }

  private Elem prvi;                  // Poetak liste.
                                      // Inicijalizacija:
  public Lista1a() {}                 // - prazna lista,
  public Lista1a(int b)               // - lista od jednog broja.
    { prvi = new Elem(b); }
  
  public void Prazni()                // Pranjenje liste.
    { prvi = null; }
 
  public int Duz   {                  // Broj elemenata liste.
    get {
      int n = 0;
      for (Elem tek=prvi; tek!=null;
           tek=tek.sled) n++;
      return n;
    }
  }

  public override string ToString() { // Tekstualni opis.
    string s = "";
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      s += tek.broj + " ";
    return s;
  }
  
  public void NaPocetak(int b)    // Dodavanje
    { prvi = new Elem(b, prvi); } //   na poetak.

  public void NaKraj(int b) {     // Dodavanje na kraj.
    Elem novi = new Elem(b);
    if (prvi == null) prvi = novi;
    else {
      Elem tek = prvi;
      while (tek.sled != null)
        tek = tek.sled;
      tek.sled = novi;
    }
  }
  
  public void Citaj1(int n) {     // itanje liste sta-
    prvi = null;                  //   vljajui brojeve
    for (int i=0; i<n; i++)       //   na poetak.
      prvi = new Elem(Citaj.Int(), prvi);
  }
  
  public void Citaj2(int n) {     // itanje liste stavljajui
    Elem posl = prvi = null;      //   brojeve na kraj.
    for (int i=0; i<n; i++) {
      Elem novi = new Elem(Citaj.Int());
      if (prvi == null) prvi = novi;
        else posl.sled = novi;
      posl = novi;
    }
  }
  
    
  public void Umetni(int b) {     // Umetanje u ureenu listu.
    Elem tek = prvi, pret = null;
    while (tek != null && tek.broj < b)
      { pret = tek; tek = tek.sled; }
    Elem novi = new Elem(b, tek);
    if (pret == null) prvi = novi;
      else pret.sled = novi;
  }
 
  public void Izostavi(int b) {   // Izostavljanje svakog
    Elem tek = prvi, pret = null; //   pojavljivanja broja.
    while (tek != null)
      if (tek.broj != b) {
        pret = tek; tek = tek.sled;
      } else {
        tek = tek.sled;
        if (pret == null) prvi = tek;
          else pret.sled = tek;
      }
  }
}
