// Lista1b.cs - Klasa listi celih brojeva (rekurzivno).

public class Lista1b {

  private class Elem {                // Element liste:
    public int broj;                  // - sadraj,
    public Elem sled;                 // - sledei element,
    public Elem(int b, Elem s=null)   // - enicijalizacija.
      { broj = b; sled = s; }
  }

  private Elem prvi;                  // Poetak liste.
                                      // Inicijalizacija:
  public Lista1b() {}                 // - prazna lista,
  public Lista1b(int b)               // - lista od jednog broja.
    { prvi = new Elem(b); }

  public void Prazni()                // Pranjenje liste.
    { prvi = null; }

  public int Duz                      // Broj elemenata liste.
    { get { return duz(prvi); } }

  public override string ToString()   // Tekstualni opis.
    { return toString(prvi); }

  public void NaPocetak(int b)        // Dodavanje na poetak.
    { prvi = new Elem(b, prvi); }

  public void NaKraj(int b)           // Dodavanje na kraj.
    { naKraj(ref prvi, b); }

  public void Citaj1(int n) {         // itanje liste stavljajui
    { prvi = citaj1(n); }}            //   brojeve na poetak.

  public void Citaj2(int n)           // itanje liste stavljajui
    { prvi = citaj2(n); }             //   brojeve na kraj.

  public void Umetni(int b)           // Umetanje u ureenu listu.
    { umetni(ref prvi, b); }

  public void Izostavi(int b)         // Izostavljanje svakog
    { izostavi(ref prvi, b); }        //   pojavljivanja broja.

  // POMONE REKURZIVNE METODE:
  private static int duz(Elem lst)                // Broj elemenata liste.
    { return (lst != null) ? 1+duz(lst.sled) : 0; }


  private static string toString(Elem lst) {      // Tekstualni opis.
    return (lst != null) ?
      lst.broj + " " + toString(lst.sled) : "";
  }

  private static void naKraj(ref Elem lst, int b){// Dodavanje na kraj.
    if (lst == null) lst = new Elem(b);
      else naKraj(ref lst.sled, b);
  }

  private static Elem citaj1(int n) {             // itanje stavljajui na
    if (n == 0) return null;                      //   poetak.
    Elem novi = new Elem(0);
    novi.sled = citaj1(n-1);
    novi.broj = Citaj.Int();
    return novi;
  }

  private static Elem citaj2(int n) {             // itanje stavljajui na
    if (n == 0) return null;                      //   kraj.
    Elem novi = new Elem(Citaj.Int());
    novi.sled = citaj2(n-1);
    return novi;
  }

  private static void umetni(ref Elem lst, int b){// Umetanje u ureenu
    if (lst==null || lst.broj>=b)                 //   listu.
      lst = new Elem(b, lst);
    else {
      umetni(ref lst.sled, b);
    }
  }

  private static void izostavi(ref Elem lst, int b) {// Izostavljanje svakog
    if (lst != null) {                               //   pojavljivanja.
      izostavi(ref lst.sled, b);
      if (lst.broj == b) lst = lst.sled;
    }
  }
}
