// Lista2.cs - Klasa listi objekata.

namespace Liste {
  using System.Text;

  public class Lista {
    private Elem prvi, posl;             // Poetak i kraj liste.

    protected class Elem {               // Element liste objekata:
      public object obj;                 // - sadrani objekat,
      public Elem pret, sled;            // - prethodni i sledei element,
      public Elem(object o, Elem p, Elem s) // - konstruktor.
        { obj = o; pret = p; sled = s; }
    } 
 
    public Lista Dodaj(object obj) {     // Dodavanje objekta na kraj liste.
      Elem novi = new Elem(obj, posl, null);
      if (prvi == null) prvi = novi; else posl.sled = novi;
      posl = novi;
      return this;
    }

    public Lista Izbaci(object obj) {    // Izbacivanje objekta iz liste.
      Elem tek = prvi; while (tek!=null && tek.obj!=obj) tek=tek.sled;
      if (tek == null) throw new GreLstNemaObj(obj);
      izbaci(tek);
      return this;
    }

    private void izbaci(Elem e) {        // Izbacivanje elementa.
      if (e.pret != null) e.pret.sled=e.sled;
      else prvi = e.sled;
      if (e.sled != null) e.sled.pret=e.pret;
      else posl = e.pret;
    }

    protected Elem tek;                  // Tekui element liste.

    public Lista NaPrvi()                // Pomeranje na prvi element.
      { tek = prvi; return this;}

    public bool ImaTek { get { return tek != null; } } // Ima li tekueg?

    public Lista NaSledeci() {           // Pomeranje na sledei element.
      if (ImaTek) tek = tek.sled;
      return this;
    }

    public object DohvatiTek() {         // Dohvatanje tekueg objekta.
      if (!ImaTek) throw new GreLstNemaTek(); 
      return tek.obj;
    }

    public object IzvadiTek() {          // Vaenje tekueg objekta.
      if (!ImaTek) throw new GreLstNemaTek();
      object obj = tek.obj; izbaci(tek); tek = tek.sled;
      return obj;
    }

    public Lista Isprazni()             // Pranjenje liste.
      { prvi = posl = tek = null; return this; }

    public override string ToString() {  // Tekstualni oblik.
      StringBuilder s = new StringBuilder('<');
      for (Elem tek=prvi; tek!=null; tek=tek.sled) {
        if (tek != prvi) s.Append(" # ");
        s.Append(tek.obj);
      }
      return s.Append('>').ToString();
    }
  }
}
