// Lista3.cs - Generika klasa listi.

using System.Collections.Generic;
using System.Collections;

public class Lista3<E>: IEnumerable<E> {
  private class Elem<T> {                   // Element liste.
    public T t;
    public Elem<T> sled = null;
    public Elem(T tt) { t = tt; }
  }
  
  private Elem<E> prvi = null, posl = null; // Poetak i kraj liste.

  public void Dodaj(E e) {                  // Dodavanje elementa.
    Elem<E> novi = new Elem<E>(e);
    if (prvi == null) prvi = novi; else posl.sled = novi;
    posl = novi;
  }
  
  public IEnumerator<E> GetEnumerator()     // Stvaranje iteratora.
    { return new Iter(this); }
  
  private class Iter: IEnumerator<E> {      // KLASA ITERATORA:
    private Lista3<E> lst;                  // Lista koja se obilazi.
    private Elem<E>   tek = null;           // Tekui element.
    private bool      poc = true;           // Da li je iterator na poetku?

    public Iter(Lista3<E> lis) { lst=lis; } // Inicijalizacija.

    public bool MoveNext() {                // Nastavak obilaska. 
      if (poc) { tek = lst.prvi; poc = false; }
      else if (tek != null) tek = tek.sled;
      return tek != null;
    }
    
    public E Current                        // Dohvatanje tekueg objekta.
      { get { return tek!=null ? tek.t : default(E); } }
    
    public void Reset()                     // Povratak na poetak zbirke.
      { tek = lst.prvi; poc = true; }

    object IEnumerator.Current              // Zahteva IEnumerator.
      { get { return Current; } }

    public void Dispose() {}                // Zahteva IDisposable.
  }

  IEnumerator IEnumerable.GetEnumerator()   // Zahteva IEnumerable.
    { return GetEnumerator(); }
}
