// Lista4.cs - Generika klasa ureenih listi.

using System.Text;

public class Lista4<E> {
  private class Elem<T> {                           // Element liste.
    public T t;
    public Elem<T> sled;
    public Elem(T t, Elem<T> s)
      { this.t = t; sled = s; }
  }
  
  Elem<E> prvi;                                     // Poetak liste.
  Ispred<E> ispred;                                 // Korieni uporeiva.
  
  public Lista4(Ispred<E> i) { ispred = i; }        // Inicijalizacija.
  
  public Lista4<E> Dodaj(E e) {                     // Dodavanje podatka.
    Elem<E> tek = prvi, pret = null;
    while (tek!=null && ispred(tek.t, e))
      { pret = tek; tek = tek.sled; }
    Elem<E> novi = new Elem<E>(e, tek);
    if (pret == null) prvi = novi; else pret.sled = novi;
    return this;
  }
  
  public override string ToString() {               // Tekstualni opis.
    StringBuilder sb = new StringBuilder();
    for (Elem<E> tek=prvi; tek!=null; tek=tek.sled) {
      sb.Append(tek.t);
      if (tek.sled != null) sb.Append(" ");
    }
    return sb.ToString();
  }
}
