// Lista4Test.cs - Ispitivanje klase ureenih listi.

using System;

public class Lista4Test {
  // Generator jednocifrenih celih brojeva.
  private static Random gen = new Random();
  private static int sluc() { return gen.Next(10); }

  // Ugneena klasa klasa parova celih brojeva.
  private struct Par{
    public int a, b;

    public Par(int x, int y) { a = x; b = y; }      // Inicijalizacija.

    public static bool Ispred(Par p, Par q)         // Uporeivanje.
      {return p.a<q.a || p.a==q.a && p.b<q.b; }

    public override string ToString()               // Tekstualni opis.
      { return "(" + a + "," + b + ")"; }
  }
    
  // Glavna metoda.
  static void Main() {
    // Lista parova (uporeiva je statika metoda).
    Lista4<Par> lstPar1 = new Lista4<Par>(Par.Ispred);
    for (int i=0; i<10; i++) lstPar1.Dodaj(new Par(sluc(), sluc()));
    Console.WriteLine(lstPar1);

    // Lista parova (uporeiva je lambda izraz).
    Lista4<Par> lstPar2 = new Lista4<Par>(
      (p,q) => p.a<q.a || p.a==q.a && p.b<q.b
    );
    for (int i=0; i<10; i++) lstPar2.Dodaj(new Par(sluc(), sluc()));
    Console.WriteLine(lstPar2);
    
    // Lista celih brojeva (uporeiva je lambda izraz).
    Lista4<int> lstInt = new Lista4<int>((a,b)=> a>b);
    for (int i=0; i<30; i++) lstInt.Dodaj(sluc());
    Console.WriteLine(lstInt);
  }
}
