// Lista5.cs - Generika klasa listi podataka.

namespace Nastava {
  public class Lista<E> {
    private class Elem<T> {                // Element liste:
      public T pod;                        // - sadrani podatak,
      public Elem<T> sled;                 // - sledei element,
      public Elem(T p, Elem<T> s=null)     // - inicijalizacija.
        { pod = p; sled = s; }
    };
   
    private Elem<E> prvi, posl;            // Prvi i poslednji element.
    private Elem<E> tek, pret;             // Tekui i prethodni element.

    public Lista<E> Dodaj(E e) {           // Dodavanje na kraj.
      Elem<E> novi = new Elem<E>(e);
      if (prvi == null) prvi = novi; else posl.sled = novi;
      posl = novi;
      return this;
    }
   
    public Lista<E> NaPrvi()               // Postavljanje na prvi element.
      { tek = prvi; pret = null; return this; }

    public Lista<E> NaSled() {             // Pomeranje na sledei element.
      pret = tek;
      if (tek != null) tek = tek.sled;
      return this;
    }
   
    public bool ImaTek { get { return tek != null; } } // Ima li tekueg?
   
    public E Tek { get {                   // Pristup tekuem podatku:
      if (tek == null) throw new GreNemaTek();
      return tek.pod;
    }}

    public Lista<E> IzbaciTek() {          // Izbacivanje tekueg elementa.
      if (tek == null) throw new GreNemaTek();
      tek = tek.sled;
      if (pret == null) prvi = tek; else pret.sled = tek;
      if (tek == null) posl = pret;
      return this;
    }
   
    public Lista<E> Isprazni() {           // Pranjenje liste.
      prvi = posl = tek = pret = null;
      return this;
    }
  }
}
