// Masina2.cs  Klasa maina za izvlaenje.

namespace Lutrija {
  using System;

  public class Masina {
    private Tocak[] niz;                     // Tokovi.
    private int n;                           // Broj aktivnih tokova.
    private bool radi = false;               // Da li radi?
    private static Random sluc=new Random(); // Generator sluajnih brojeva.

    public Masina(int kap) {                 // Inicijalizacija.
      niz = new Tocak [kap];
      for (int i=0; i<kap; i++)
        niz[i] = new Tocak(sluc.Next(10, 21), i%2==0);
    }

    public void Kreni(int n) {               // Pokretanje.
      if (radi) throw new GreRadi();
      if (n<=0 || n>niz.Length) throw new GreDuz();
      radi = true; this.n = n;
      for (int i=0; i<n; niz[i++].Kreni());
    }

    public string Stani() {                  // Zaustavljanje sa oitavanjem
      if (!radi) throw new GreStoji();       //   stanja tokova.
      radi = false; string s = "";
      for (int i=0; i<n; s=niz[i++].SlBroj()+s);
      return s;
    }

    public void Unisti ()                    // Prekidanje niti tokova.
      { foreach (Tocak t in niz) t.Zavrsi(); }
  }
}
