// Mnogougao.cs - Klasa pomerljivih mnogouglova u ravni.

namespace Figure2 {
  public class Mnogougao: Figura {
    Niz<Tacka> tem;                                     // Temena mnogougla.
  
    public Mnogougao(int brTem=3)                       // Inicijalizacija.
      { tem = new Niz<Tacka>(brTem); }
  
    public Mnogougao Dodaj(Tacka t)                     // Dodavanje temena.
      { tem.Dodaj(t); return this; }

    public override void Pomeri(double dx, double dy)   // Pomeranje.
      { for (int i=0; i<tem.Duz; tem[i++].Pomeri(dx, dy)); }

    public override char Vrsta { get { return 'M'; } }  // Oznaka vrste.

    public override Tacka Teziste { get {               // Teite.
      double x = 0, y = 0;
      int n = tem.Duz;
      for (int i=0; i<n; i++) { x += tem[i].X; y += tem[i].Y; }
      return new Tacka(x/n, y/n);
    }}
  
    public override string ToString()                   // Tekstualni opis.
      { return base.ToString() + tem; }
  }
}
