// NULista.cs - Klasa neureenih listi.

namespace Zbirke {
  public class NULista: ALista {
    public override IZbirka Dodaj(int b) {  // Dodavanje elementa.
      Elem novi = new Elem(b);
      if (prvi == null) prvi = novi; else posl.sled = novi;
      posl = novi;
      n++;
      return this;
    }
  
    public override int this[int i] {       // Pristupanje elementu:
      get { return Nadji(i).broj; }         // - dohvatanje,
      set { Nadji(i).broj = value; }        // - postavljanje.
    }

    public override IIterator Iterator()    // Stvaranje iteratora.
      { return new IterNUL(this); }

    // UGNEENA KLASA ITERATORA ZA NEUREENE LISTE.
    private class IterNUL: AIterAL {
      public IterNUL(NULista nul): base(nul) {} // Inicijalizacija.

      public override int Tek {             // Pristupanje tekuem elementu:
        get {                               // - dohvatanje,
          if (!ImaTek) throw new GreNemaTek();
          return tek.broj;
        }
        set {                               // - postavljanje.
          if (!ImaTek) throw new GreNemaTek();
          tek.broj = value;
        }
      }
    }
  }
}
