// NUNiz.cs - Klasa neureenih nizova.

namespace Zbirke {
  public class NUNiz: ANiz {
    public override IZbirka Dodaj(int b) {  // Dodavanje elementa.
      if (n == niz.Length) povecaj();
      niz[n++] = b;
      return this;
    }
  
    public override int this[int i] {       // Pristupanje elementu:
      get {                                 // - dohvatanje,
        if (i<0 || i>=n) throw new GreIndeks(i);
        return niz[i];
      }
      set {                                 // - postavljanje.
        if (i<0 || i>=n) throw new GreIndeks(i);
        niz[i] = value;
      }
    }

    public override IIterator Iterator()    // Stvaranje iteratora.
        { return new IterNUN(this); }
  
    // UGNEENA KLASA ITERATORA ZA NEUREENE NIZOVE.
    private class IterNUN: AIterAN {
      public IterNUN(NUNiz nun): base(nun) {}  // Inicijalizacija.

      public override int Tek {             // Pristupanje tekuem elementu:
        get {                               // - dohvatanje,
          if (!ImaTek) throw new GreNemaTek();
          return aNiz[tek];
        }
        set {                               // - postavljanje.
          if (!ImaTek) throw new GreNemaTek();
          aNiz[tek] = value;
        }
      }
    }
  }
}
