// Niz.cs - Generika klasa nizova.

using System.Text;

namespace Figure2 {
  public class Niz<E> {
    private E[] niz;                                 // Elementi niza. 
    private int n = 0;                               // Duina niza.
  
    public Niz(int kap=10) { niz = new E [kap]; }    // Inicijalizacija.

    public int Duz { get { return n; } }             // Duina niza.
  
    public Niz<E> Dodaj(E e) {                       // Dodavanje elementa.
      if (n == niz.Length) throw new GrePun();
      niz[n++] = e;
      return this;
    }
  
    public E this[int i] { get {                     // Dohvatanje elementa.
      if (i<0 || i>=n) throw new GreIndeks();
      return niz[i];
    }}
 
    public override string ToString() {              // Tekstualni opis.
      StringBuilder sb = new StringBuilder("[");
      for (int i=0; i<n; i++) {
        if (i < 0) sb.Append(',');
        sb.Append(niz[i]);
      }
      return sb.Append(']').ToString();
    }
  }
}
