// Odrednica.cs - Klasa odrednica u reniku.

namespace Prevodjenje {
  public class Odrednica {
    private string pojam, prevod;                   // Pojam i prevod.
  
    public Odrednica(string poj, string pre)        // Inicijalizacija.
      { pojam = poj; prevod = pre; }
  
    public string Pojam  { get { return pojam;  } } // Dohvatanje pojma i
    public string Prevod { get { return prevod; } } //   prevoda.
  
    public static bool operator==(Odrednica odr1, Odrednica odr2)
      => odr1.pojam==odr2.pojam && odr1.prevod==odr2.prevod;

    public static bool operator!=(Odrednica odr1, Odrednica odr2)
      => !(odr1 == odr2);

    public static bool operator< (Odrednica odr1, Odrednica odr2)
      => odr1.pojam.CompareTo(odr2.pojam)< 0 ||
         odr1.pojam.CompareTo(odr2.pojam)==0 &&
              odr1.prevod.CompareTo(odr2.prevod)<0;
  
    public static bool operator> (Odrednica odr1, Odrednica odr2)
      => odr1.pojam.CompareTo(odr2.pojam)> 0 ||
         odr1.pojam.CompareTo(odr2.pojam)==0 &&
              odr1.prevod.CompareTo(odr2.prevod)>0;
  
    public static bool operator<=(Odrednica odr1, Odrednica odr2)
      => !(odr1 > odr2);

    public static bool operator>=(Odrednica odr1, Odrednica odr2)
      => !(odr1 < odr2);

    public override string ToString()          // Tekstualni opis odrednice.
      => pojam + " => " + prevod;
  }
}
