// Paket.cs - Klasa paketa.

namespace Prevoz {
  public class Paket: Roba {
    private Roba[] robe;                             // Robe u paketu.
    private int n;                                   // Broj roba.
  
    public Paket(int kap) { robe = new Roba [kap]; } // Inicijalizacija.
  
    public Paket Dodaj(Roba r) {                     // Dodavanje robe.
      if (n == robe.Length) throw new GrePun();
      robe[n++] = r;
      return this;
    }

    public override double Vrednost { get {          // Vrednost paketa.
      double v = 0;
      for (int i=0; i<n; v+=robe[i++].Vrednost);
      return v;
    }}

    public override double Tezina { get {            // Teina paketa.
      double t = 0;
      for (int i=0; i<n; t+=robe[i++].Tezina);
      return t;
    }}
  
    public override object Clone() {                 // Kopija paketa.
      Paket p = (Paket)base.Clone();
      p.robe = (Roba[])robe.Clone();
      for (int i=0; i<n; i++) p.robe[i] = (Roba)robe[i].Clone();
      return p;
    }

    public override string ToString() {              // Tekstualni opis.
      string s = "[";
      for (int i=0; i<n; i++) {
        if (i > 0) s += ",";
        s += robe[i];
      }
      return s + "]";
    }
  }
}
