// PokRadnik.cs - Klasa pokretnih radnika.

namespace Trgovina2 {
  using Radionica;
  using Pokretni;
  using Police;
  using Predmeti1;
  using System;

  public class PokRadnik: Radnik, IPokretan {
    private Polica  pol;         // Odredina polica.
    private double  maxT;        // Najdue vreme proizvodnje predmeta.
    private double  t;           // Preostalo vreme do narednog dogaaja.
    private Predmet pred;        // Sledei proizvedeni predmet.
    private static Random sluc=new Random(); // Generator sluajnih brojeva.
 
    public PokRadnik(string ime, double tMax, Polica p) // Inicijalizacija.
      : base(ime) { pol = p; maxT = tMax; }
    public PokRadnik(string ime, double tMax): this(ime, tMax, null) {}

    public PokRadnik Polica(Polica p)           // Pridruivanje police.
      { pol = p; return this; }
 
    public IPokretan Proteklo(double dt) {      // Sledei korak rada.
      if ((t -= dt) <= 0) {
        try {
          if (pred != null) {
            if (pol == null) throw new GreRadNemaPol(this);
            pol.Stavi(pred);
            Console.WriteLine("Radnik " + this + " je stavio " + pred);
          }
          pred = Napravi();
          t = sluc.NextDouble() * maxT;
        } catch (GrePolPuna) {
          Console.WriteLine("Radnik " + this + " je zatekao punu policu");
        } catch (Usluge.Greska g) {
          Console.WriteLine(g);
        }
      }
      return this;
    }
  }
}
