// Poli2.cs - Klasa polinoma.

namespace Integrali {
  using Vektor;

  public class Poli: Fun {
    private Vekt a;                             // Vektor koeficijenata.

    public Poli(int n)                          // Inicijalizacija.
      { a = new Vekt(0, n); }

    public double this[int i] {                 // Pristup koeficijentu:
      get { return a[i]; }                      // - dohvatanje,
      set { a[i] = value; }                     // - postavljanje.
    }

    public int Red { get { return a.MaxInd; } } // Red polinoma.

    public override double F(double x) {        // Vrednost polinoma.
      double s = 0;
      for (int i=a.MaxInd; i>=0; s = s * x + a[i--]);
      return s;
    }

    public override double I(double x) {        // Vrednost integrala.
      double s = 0;
      for (int i=a.MaxInd; i>=0; s = s * x + a[i] / (i-- + 1));
      return s * x;
    }
  }
}
