// PolicaTest.cs - Ispitivanje klase polica za predmete.

using Police;
using Predmeti1;
using System;

public class PolicaTest {
  private class Greska: Exception {              // Klasa za lokalne greke.
    private string por;
    public Greska(string p) { por = p; }
    public override string ToString() { return "*** GRESKA: " + por; }
  }

  private static Predmet citaj() {               // itanje predmeta.
    Console.Write("Vrsta(S-sfera, K-kvadar)? ");
    Predmet p = null;
    switch (Citaj.Char()) {
      case 's': case 'S': p = new Sfera();  break;
      case 'k': case 'K': p = new Kvadar(); break;
      default: throw new Greska("Nepoznata vrsta predmeta!");
    }
    Console.Write("Spec. tez. i dimenzije? ");
    p.Citaj(); return p;
  }
 
  static void Main(string[] varg) {              // Glavna metoda.
    Polica p = new Polica(int.Parse(varg[0]),
                          double.Parse(varg[1]));
    bool kraj = false;
    while (!kraj) {
      try {
        Console.Write (
          "\n1. Dodavanje na zadato mesto\n"        +
            "2. Dodavanje na prvo slobodno mesto\n" +
            "3. Uzimanje sa zadatog mesta\n"        +
            "4. Stanje police\n"                    +
            "5. Sadrzaj police\n"                   +
            "6. Praznjenje police\n"                +
            "0. Kraj rada\n\n"                      +
            "Vas izbor? "
        );
        switch (Citaj.Char()) {
          case '1': Console.Write("Indeks? "); int i = Citaj.Int();
                    p[i] = citaj();
                    break;
          case '2': p.Stavi (citaj());
                    break;
          case '3': Console.Write ("Indeks? ");
                    Console.WriteLine(p.Uzmi(Citaj.Int()));
                    break;
          case '4': Console.WriteLine(
                      "Kapacitet= "  + p.Kapacitet + 
                      " slobodno= "  + p.Slobodno  +
                      "\nNosivost= " + p.Nosivost  +
                      " teret= "     + p.Teret       );
                    break;
          case '5': Console.Write(p);
                    break;
          case '6': p.Prazni();
                    break;
          case '0': kraj = true; break;
          default : throw new Greska("Nedozvoljen izbor!");
        }
      } catch (GrePolica g) { Console.WriteLine(g);
      } catch (Greska g)    { Console.WriteLine(g);
      }
    }
  }
}
