// Potrosac2.cs - Klasa aktivnih potroaa.

namespace Skladista {
  using System.Threading;
  using System;

  public class Potrosac: IAkter {
    private static int posId = 0;   // Poslednje korieni identifikator.
    private int id = ++posId;       // Identifikator proizvoaa.
    private Skladiste skladiste;    // Pridrueno skladite.
    private int minVreme, maxVreme; // Najkrae i najdue vreme proizvodnje.
    private Thread nit;             // Nit koja radi.
    private bool kraj = false;      // Da li treba da se zavri?
    private static Random sluc=new Random(); // Generator sluajnih brojeva.

    public Potrosac                              // Inicijalizacija.
      (Skladiste sklad, int minVr, int maxVr) { 
      minVreme = minVr; maxVreme = maxVr; 
      skladiste = sklad;
      nit = new Thread(akcija);
    }
    public Potrosac(Skladiste sklad)
      : this(sklad, 1000, 2000) {}

    public void Pocni() { nit.Start(); }         // Pokretanje niti.

    private void akcija() {                      // Sadraj niti.
      Console.WriteLine("Potros " + id + " krenuo");
      try {
        while (!kraj) {
          int vredn = skladiste.Uzmi();
          Console.WriteLine("Potros " + id + " uzeo    " + vredn);
          Thread.Sleep(sluc.Next(minVreme, maxVreme));
        }
      } catch (ThreadInterruptedException) {}
      Console.WriteLine("Potros " + id + " zavrsio");
    }

    public void Zavrsi()                         // Zavretak niti.
      { kraj = true; nit.Interrupt(); }
  }
}
