// Proizvod.cs - Apstraktna klasa uporedivih proizvoda.

using System;

namespace Trgovina1 {
  public abstract class Proizvod: IUporediv, ICloneable {
    public abstract char Oznaka { get; }          // Oznaka vrste proizvoda.

    public abstract double Zapremina { get; }     // Zapremina proizvoda.
  
    public virtual bool Istovetan(IUporediv u)    // Da li su istovetni?
      { return Oznaka == ((Proizvod)u).Oznaka; }
  
    public virtual object Clone()                 // Kopija proizvoda.
      { return MemberwiseClone(); }
  
    public override string ToString()             // Tekstualni opis.
      { return Oznaka.ToString(); }
  }
}
