// Proizvodjac.cs - Klasa aktivnih proizvoaa.

namespace Skladista {
  using System.Threading;
  using System;

  public class Proizvodjac: IAkter {
    private static int posId = 0;   // Poslednji identifikator.
    private int id = ++posId;       // Identifikator proizvoaa.
    private Skladiste skladiste;    // Pridrueno skladite.
    private int minVreme, maxVreme; // Najkrae i najdue vreme proizvodnje.
    private int broj;               // Poslednje proizvedeni podatak.
    private Thread nit;             // Nit koja radi.
    private bool kraj = false;      // Da li treba da se zavri?
    private static Random sluc=new Random(); // Generator sluajnih brojeva.


    public Proizvodjac                           // Inicijalizacija.
      (Skladiste sklad, int minVr, int maxVr) { 
      minVreme = minVr; maxVreme = maxVr; 
      skladiste = sklad;
      nit = new Thread(akcija);
    }
    public Proizvodjac(Skladiste sklad)
      : this(sklad, 1000, 2000) {}

    public void Pocni() { nit.Start(); }         // Pokretanje niti.

    private void akcija() {                      // Sadraj niti.
      Console.WriteLine("Proizv " + id + " krenuo");
      try {
        while (!kraj) {
          Thread.Sleep(sluc.Next(minVreme, maxVreme));
          int vredn = id*1000 + ++broj; 
          Console.WriteLine("Proizv " + id + " stavlja " + vredn);
          skladiste.Stavi(vredn);
        }
      } catch (ThreadInterruptedException) {}
      Console.WriteLine("Proizv " + id + " zavrsio");
    }

    public void Zavrsi()                         // Zavretak niti.
      { kraj = true; nit.Interrupt(); }
  }
}
