// Prom.cs - Klasa promenljivih.

using System;

namespace Izrazi {
  public class Prom: Izraz {
    private class Elem {                // Element liste svih promenljivih:
      public string ime;                // - ime,
      public double vr;                 // - vrednost,
      public int brKor;                 // - broj korienja,
      public Elem pret, sled;           // - prethodni i sledei u listi,
      public Elem(string i, double v, Elem p, Elem s) // - inicijalizacija.
        { ime = i; vr = v; pret = p; sled = s; brKor = 1; }
    }

    private static Elem prvi = null;    // Poetak liste svih promenljivih.
    private Elem ovaj;                  // Element pridruen ovom objektu.
                                               // Inicijalizacija:
    public Prom(string ime, double vr) {       // - imenom i brojem,
      Elem tek = prvi, pret = null; int p = 0;
      while (tek!=null && (p=tek.ime.CompareTo(ime))<0)
        { pret = tek; tek = tek.sled; }
      if (tek!=null && p==0) {
        ovaj = tek; ovaj.brKor++;
      } else {
        ovaj = new Elem(ime, vr, pret, tek);
        if (tek != null) tek.pret = ovaj;
        if (pret == null) prvi = ovaj; else pret.sled = ovaj;
      }
    }

    public Prom(string ime): this(ime, 0) {}   // - imenom,

    public Prom(string ime, Izraz i)           // - imenom i izrazom,
      : this(ime, i.Vr()) {}

    public Prom(Prom p)                        // - kopijom promenljive.
      { ovaj = p.ovaj; ovaj.brKor++; }

    public void Brisi() {                      // Unitavanje.
      if (--ovaj.brKor == 0) {
        if (ovaj.pret != null) ovaj.pret.sled = ovaj.sled;
          else prvi = ovaj.sled;
        if (ovaj.sled != null) ovaj.sled.pret = ovaj.pret;
      }
    }
                                               // Dodela vrednosti:
    public Prom Postavi(double v)              // - realnog broja,
      { ovaj.vr = v; return this; }

    public Prom Postavi(Izraz i)               // - izraza.
      { ovaj.vr = i.Vr(); return this; }

    public override double Vr()                // Vrednost promenljive.
      { return ovaj.vr; }
  
    public override string ToString()          // Tekstualni opis.
      { return ovaj.ime; }

    public static void pisiSve() {             // Spisak svih promenljivih.
      for (Elem tek=prvi; tek!=null; tek=tek.sled)
        Console.Write(tek.ime + " ");
      Console.WriteLine();
    }
  }
}
