// PromVel - Apstraktna klasa promenljivih fizikih veliina.

namespace Merenje {
  using System.Threading;
  using System;

  public abstract class PromVel: IVel {
    private int tmin, tmax;                // Granina vremena promena.
    private double vr, min, max;           // Trenutna i granine vrednosti.
    double delta;                          // Iznos promene.
    private Thread nit;                    // Nit koja radi.
    private bool kraj = false;             // Da li treba da se zavri?
    private static Random sluc=new Random(); // Generator sluajnih brojeva.

    public PromVel(int mint, int maxt,     // Inicijalizacija.
                   double vr0, double del, double minVr, double maxVr) {
      tmin = mint; tmax = maxt;
      vr = vr0; delta = del; min = minVr; max = maxVr;
      (nit = new Thread(akcija)).Start();
    }

    public double Vrednost                 // Trenutna vrednost veliine.
      { get { lock (this) {return vr; } } }

    public abstract string Jedinica {get;} // Jedinica mere.

    private void akcija() {                // Telo niti.
      try {
        while (!kraj) {
        int t = sluc.Next(tmin, tmax);
          Thread.Sleep(t);
          lock (this) {
            vr += (sluc.NextDouble()*2 - 1) * delta;
            if (vr < min) vr = min;
            if (vr > max) vr = max; 
          }
        }
      } catch (ThreadInterruptedException) {}
    }

    public void Prekini()                  // Zavretak niti.
      { kraj = true; nit.Interrupt(); }
  }
}
