// Radnik2.cs - Klasa radnika.

using Predmeti1;

namespace Radionica {
  public class Radnik {
    private static int posId = 0;  // Poslednji identifikator.
    private int id = ++posId;      // Identifikator radnika.
    private string ime;            // Ime radnika.
    private Masina mas;            // Maina koju radnik koristi.
    private int br;                // Broj napravljenih proizvoda na maini.

    public Radnik(string iime) { ime = iime; } // Inicijalizacija.

    public int Id { get { return id; }  }      // Dohvatanje identifikatora
    public string Ime { get { return ime; } }  //   i imena.

    public Radnik Rasporedi(Masina m)          // Rasporeivanje na mainu.
      { mas = m; br = 0; return this; }

    public Masina Mas { get { return mas; } }  // Dohvatanje maine.

    public int Broj { get {                 // Broj napravljenih predmeta.
      if (mas == null) throw new GreNemaMas(ime, id);
      return br;
    }}

    public Predmet Napravi() {                 // Pravljenje predmeta.
      if (mas == null) throw new GreNemaMas(ime, id);
      br++; 
      return mas.Napravi();
    }

    public override string ToString() {        // Tekstualni opis.
      string s = ime + "/" + id;
      if (mas != null) s += "(" + mas.Vrsta + "," + br + ")";
      return s;
    }
  }
}
