// Recnik1.cs - Klasa renika.

namespace Prevodjenje {
  public class Recnik {
    private class Elem {                  // Element liste odrednica:
      public Odrednica odred;             // - odrednica,
      public Elem sled;                   // - sledea odrednica,
      public Elem(Odrednica odr, Elem s)  // - stvaranje elementa.
        { odred = odr; sled = s; }
    }

    Elem prvi = null;                     // Poetak liste.

    public bool Dodaj(Odrednica odr) {    // Dodavanje nove odrednice.
      Elem tek = prvi, pret = null;
      while (tek!=null && tek.odred<odr)
         { pret = tek; tek = tek.sled; }
      if (tek!=null && tek.odred==odr) return false;
      Elem novi = new Elem(odr, tek);
      if (pret == null) prvi = novi; else pret.sled = novi;
      return true;
    }
  
    public string[] Prevodi(string poj) { // Svi prevodi pojma.
      Elem tek = prvi;
      while (tek!=null && tek.odred.Pojam.CompareTo(poj)<0)
        tek = tek.sled;
      string s = "";
      while (tek!=null && tek.odred.Pojam==poj) {
        s += tek.odred.Prevod + "\0";
        tek = tek.sled;
      }
      return s.Split('\0');
    }
  
    public override string ToString() {   // Tekstualni opis renika.
      string s = "";
      for (Elem tek=prvi; tek!=null; tek=tek.sled)
        s += tek.odred + "\n";
      return s;
    }
  }
}
