// Red.cs - Klasa redova neograni-
//            enog kapaciteta.

using System;

class Red {
  private class Elem {                               // Element liste:
    public int broj;                                 // - sadraj,
    public Elem sled;                                // - sledei element,
    public Elem(int b, Elem s=null)                  // - inicijalizacija.
      { broj = b; sled = s; }
  }

  private Elem prvi, posl;                           // Poetak i kraj reda.

  public void Stavi(int broj) {                      // Stavljanje na kraj.
    Elem novi = new Elem(broj);
    if (prvi == null) prvi = novi; else posl.sled = novi;
    posl = novi;
  }
  
  public int Uzmi() {                                // Uzimanje s poetka.
    if (prvi == null) {
      Console.Write("\n*** Red je prazan ***\n");
      Environment.Exit(1);
    }
    int b = prvi.broj;
    if ((prvi = prvi.sled) == null) posl = null;
    return b;
  }

  public void Prazni() { prvi = posl = null; }       // Pranjenje reda.
  
  public bool Prazan { get { return prvi == null; }} // Da li je prazan?
 
  public override string ToString() {                // Tekstualni opis.
    string s = "";
    for (Elem tek=prvi; tek!=null; tek=tek.sled) 
      s += tek.broj + " ";
    return s;
  }
}
