// Sekvenca.cs - Klasa sekvenci.

namespace Naredbe {
  public class Sekvenca: Naredba {
    private class Elem {                       // Element sekvence:
      public Naredba nar;                      // - sadrana naredba,
      public Elem sled;                        // - sledei element liste,
      public Elem(Naredba n) { nar = n; }      // - inicijalizacija.
    }

    private Elem prva, posl;                   // Prva i poslednja naredba.

    public Sekvenca Dodaj(Naredba n) {         // Dodavanje naredbe.
      Elem novi = new Elem(n);
      if (prva == null) prva = novi; else posl.sled = novi;
      posl = novi;
      return this;
    }

    public override void Izvrsi()              // Izvravanje.
      { for (Elem tek=prva; tek!=null; tek=tek.sled) tek.nar.Izvrsi(); }

    public override string ToString() {        // Tekstualni opis.
      string s = Nivo + "{\n";
      Nivo += "  ";
      for (Elem tek=prva; tek!=null; tek=tek.sled) s += tek.nar;
      Nivo = Nivo.Substring (2);
      return s + Nivo + "}\n";
    }
  }
}
