// Skladiste1.cs - Klasa skladita proizvoda.

namespace Trgovina1 {
  using Trgovina1.Greske;

  public class Skladiste {
    private Proizvod[] niz;             // Mesta za proizvode.
    private double maxZapr, trenZapr=0; // Dozvoljena i trenutna zapremina.

    public Skladiste(int kap, double maxV)        // Inicijalizacija.
      { niz = new Proizvod [kap]; maxZapr = maxV; }
  
    public Skladiste(double maxV): this(10, maxV) {}
 
    public Skladiste Stavi(Proizvod p) {          // Stavljanje proizvoda.
      if (trenZapr + p.Zapremina > maxZapr) throw new GreZapremina();
      int i=0; while (i<niz.Length&&niz[i]!=null) i++;
      if (i == niz.Length) throw new GreNemaMesta();
      niz[i] = p;
      trenZapr += p.Zapremina;
      return this;
    }

    public Proizvod Uzmi(Proizvod p) {            // Uzimanje proizvoda.
      int i = 0; while (i<niz.Length &&
        (niz[i]==null || !niz[i].Istovetan(p))) i++;
      if (i == niz.Length) throw new GreNemaProizvoda();
      p = niz[i]; niz[i] = null;
      trenZapr -= p.Zapremina;
      return p;
    }
  
    public int ImaMesta { get {                   // Broj slobodnih mesta.
      int k = 0;
      for (int i=0; i<niz.Length; i++)
        if (niz[i] == null) k++;
      return k;
    }}

    public double ImaZapr                         // Slobodna zapremina.
      { get { return maxZapr - trenZapr; } }
  }
}
