// SlozenOtpornik.cs - Apstraktna klasa sloenih otpornika.

using System.Text;

namespace Otpornici {
  public abstract class SlozenOtpornik: ApstraktanOtpornik {
    protected class Elem {                           // Element liste:
      public ApstraktanOtpornik R;                   // - sadrani otpornik,
      public Elem sled;                              // - sledei element,
      public Elem(ApstraktanOtpornik r) { R = r; }   // - inicijalizacija.
    }
    protected Elem prvi, posl; // Poetak i kraj liste sadranih otpornika.
  
    public SlozenOtpornik Dodaj(ApstraktanOtpornik r) { // Dodavanje 
      Elem novi = new Elem(r);                          //   otpornika.
        if (prvi == null) prvi = novi;
          else            posl.sled = novi;
        posl = novi;
      return this; 
    }
                                  // Simboli za tekstualni opis:
    protected abstract char Otv (); // - otvorena zagrada,
    protected abstract char Oper(); // - operator,
    protected abstract char Zatv(); // - zatvorena zagrada.
  
    public override sealed string ToString() {          // Tekstualni opis.
      StringBuilder sb = new StringBuilder();
      sb.Append(Otv());
      for (Elem tek=prvi; tek!=null; tek=tek.sled) {
        sb.Append(tek.R);
        if (tek.sled != null) sb.Append(Oper());
      }
      return sb.Append(Zatv()).ToString();
    }
  }
}
