// StatistikaTest.cs - Ispitivanje klasa generatora sluajnih brojeva.

using Statistika;
using System;

class StatistikaTest {
  static IPokazatelj[] pokaz = { // Sastavljai statistikih pokazatelja.
    new Brojac(), new Minimum(), new Maximum(),
    new Srednja(), new Devijacija()
  };

  static void Main() {           // Glavna metoda.
    // Generator sluajnih brojeva.
    ISlucajan gen = new Uniforman();

    // Statistiki analizator.
    Analizator analizator = new Analizator();

    foreach (IPokazatelj pok in pokaz)
      // Registrovanje oslukivaa dodajui dogaaju delegate
      // inicijalizovanim metodama odgovarajueg potpisa.
      analizator.NovUzorak += new Rukovalac(pok.Azuriraj);

    // Obrada koja generie dogaaje.
    analizator.Radi(gen, 10000);

    // Prikazivanje rezultata.
    foreach (IPokazatelj pok in pokaz)
      Console.WriteLine(pok + ": " + pok.Uzmi);
  }
}
