// Stek2.cs - Generika klasa stekova.

using Usluge;

public class Stek<T> {
  private T[] niz;                                    // Stek u obliku niza.
  private int vrh;                                    // Indeks vrha steka.
	
  public Stek(int kap) { niz = new T [kap]; }         // Inicijalizacija.
  
  public void Stavi(T t) {                            // Stavljanje.
    if (vrh == niz.Length) throw new Greska("*** Stek je pun!");
    niz[vrh++] = t;
  }
  
  public T Uzmi() {                                   // Uzimanje.
    if (vrh == 0) throw new Greska("*** Stek je prazan!");
    return niz[--vrh];
  }
  
  public bool Pun { get { return vrh == niz.Length; }}// Da li je pun?
  
  public bool Prazan { get { return vrh == 0; } }     // Da li je prazan?
}
