// Tacka5.cs - Klasa pokretnih taaka.

namespace Pokretni {
  public class Tacka: IPokretan {
    private static int posId = 0;         // Poslednji identifikator.
    private readonly int id = ++posId;    // Identifikator take.
    private Vektor r;                     // Vektor poloaja.
    private Brzina v;                     // Vektor brzine.

    public Tacka(Vektor rr, Brzina vv) { r = rr; v = vv; } // Inicijali-
    public Tacka() { r = new Vektor(); v = new Brzina(); } //   zacija.

    public IPokretan Proteklo(double dt)  // Promena poloaja zbog
      { r += v * dt; return this; }       //   proteklog vremena.

    public Vektor R { get { return r; } } // Trenutni poloaj.

    public double Rastojanje(Tacka T2)    // Rastojanje od druge take.
      { return (T2.R + this.R * -1).Intenzitet; }

    public override string ToString()     // Tekstualni opis.
      { return "T" + id + R; }
  }
}
