// Teret.cs - Apstraktna klasa tereta.

namespace Zeleznica {
  public abstract class Teret {
    private static int posId = 0;                // Poslednji identifikator.
    private int id = ++posId;                    // Identifikator tereta.
    private double sigma;                        // Specifina teina.

    public Teret(double s) { sigma = s; }        // Inicijalizacija

    public abstract char Vrsta { get; }          // Oznaka vrste.
  
    public abstract double Zapr { get; }         // Zapremina.
  
    public double Tezina { get { return Zapr * sigma; } } // Teina.
  
    public override string ToString()            // Tekstualni opis.
      { return "" + Vrsta + id; }
  }
}
