// Tocak.cs - Klasa tokova maine za izvlaenje.

namespace Lutrija {
  using System.Threading;

  public class Tocak: IGenerator {
    private Thread nit;                      // Nit koja radi.
    private int cifra;                       // Trenutna cifra.
    private int dt;                          // Vreme izmeu dve promene.
    private int korak;                       // Korak promene (smer).
    private bool radi = false;               // Da li se vrti?
    private bool kraj = false;               // Da li treba da se zavri?

    public Tocak(int ddt, bool raste) {      // Inicijalizacija.
      dt = ddt; korak = raste ? 1 : -1;
      (nit = new Thread(akcija)).Start();
    }

    private void akcija() {                  // Telo niti.
      try {
        while (!kraj) {
          lock (this) { if (!radi) Monitor.Wait(this); }
          Thread.Sleep(dt);
          cifra = (cifra + korak + 10) % 10;
        }
      } catch (ThreadInterruptedException) {}
    }

    public void Kreni()                      // Pokretanje toka.
      { lock (this) { radi = true; Monitor.Pulse(this); } }

    public int SlBroj()                      // Zaustavljanje i oitavanje.
      { radi = false; return cifra; }

    public void Zavrsi()                     // Zavretak niti.
      { kraj = false; nit.Interrupt(); }
  }
}
