// Trougao2.cs - Klasa trouglova.

using System;

class Trougao {
  private static int posId = 0;           // Poslednji identifikator.
  private int id = ++posId;               // Identifikator trougla.
  private double a, b, c;                 // Stranice trougla.

                                          // Da li su stranice prihvatljive?
  public static bool Moze(double a, double b, double c)
    { return a>0 && b>0 && c>0 && a+b>c && b+c>a && c+a>b; }

  public Trougao(double aa, double bb, double cc) { // Stvaranje trougla.
    if (!Moze(aa, bb, cc)) Environment.Exit(1);
    a = aa; b = bb; c = cc;
  }

  public double A() { return a; }         // Dohvatanje stranica trougla.
  public double B() { return b; }
  public double C() { return c; }

  public double O() { return a + b + c; } // Obim trougla.

  public double P() {                     // Povrina trougla.
    double s = O() / 2;
    return Math.Sqrt(s * (s-a) * (s-b) * (s-c));
  }

  public override string ToString()       // Tekstualni opis trougla.
    {  return "Troug" + id + "(" + a + "," + b + "," + c + ")"; }
}
