// ULista.cs - Klasa ureenih listi.

namespace Zbirke {
  public class ULista: ALista {
    public override IZbirka Dodaj(int b) {  // Dodavanje elementa.
      Elem tek = prvi, pret = null;
      while (tek!=null && tek.broj<= b) { pret = tek; tek = tek.sled; }
      novi = new Elem(b); npret = pret; n++;
      if (pret == null) prvi = novi; else pret.sled = novi;
      novi.sled = tek;
      if (tek == null) posl = tek;
      return this;
    }
  
    private Elem novi, npret;   // Novododati i njemu prethodni element.
  
    public override int this[int i] {       // Pristupanje elementu:
      get { return Nadji(i).broj; }         // - dohvatanje,
      set { Nadji(i).broj = value;          // - postavljanje.
        if (i<0 || i>=n) throw new GreIndeks(i);
        Brisi(i); Dodaj(value);
      }
    }

    public override IIterator Iterator()    // Stvaranje iteratora.
      { return new IterUL(this); }
  
    // UGNEENA KLASA ITERATORA ZA UREENE LISTE.
    private class IterUL: AIterAL {
      public IterUL(ULista ul): base(ul) {} // Inicijalizacija.

      public override int Tek {             // Pristupanje tekuem elementu:
        get {                               // - dohvatanje,
          if (!ImaTek) throw new GreNemaTek();
          return tek.broj;
        }
        set {                               // - postavljanje.
          ULista ul = ((ULista)aLista);
          if (!ImaTek) throw new GreNemaTek();
          int i = 0; for (Elem t=ul.prvi; t!=tek; t=t.sled) i++;
          aLista[i] = value;
          tek = ul.novi; pret = ul.npret;
        }
      }
    }
  }
}
