// UNiz.cs - Klasa ureenih nizova.

namespace Zbirke {
  public class UNiz: ANiz {
    public override IZbirka Dodaj(int b) {  // Dodavanje elementa.
      if (n == niz.Length) povecaj();
      int i = n; while (i>0 && niz[i-1]>b) niz[i] = niz[--i];
      niz[i] = b; n++;
      return this;
    }

    public override int this[int i] {       // Pristupanje elementu:
      get {                                 // - dohvatanje,
        if (i<0 || i>=n) throw new GreIndeks(i);
        return niz[i];
      }
      set {                                 // - postavljanje.
        if (i<0 || i>=n) throw new GreIndeks(i);
        if (value > niz[i])
          while (i< value && niz[i]<value) niz[i]=niz[++i];
        else if (value < niz[i])
          while (i>=0 && niz[i]>value) niz[i]=niz[--i];
        niz[i] = value; novoMesto = i;
      }
    }

    private int novoMesto;      // Mesto elementa posle promene vrednosti.

    public override IIterator Iterator()    // Stvaranje iteratora.
      { return new IterUN(this); }

    // UGNEENA KLASA ITERATORA ZA UREENE NIZOVE.
    private class IterUN: AIterAN {
      public IterUN(UNiz un): base(un) {}   // Inicijalizacija.

      public override int Tek {             // Pristupanje tekuem elementu:
        get {                               // - dohvatanje,
          if (!ImaTek) throw new GreNemaTek();
          return aNiz[tek];
        }
        set {                               // - postavljanje.
          if (!ImaTek) throw new GreNemaTek();
          aNiz[tek] = value;
          tek = ((UNiz)aNiz).novoMesto;
        }
      }
    }
  }
}
