// Uniforman.cs - Klasa generatora sluajnih brojeva
//                s unifromnom raspodelom.

namespace Statistika {
  using System;
  public class Uniforman: ISlucajan {
    private uint klica =              // Klica generatora.
      (uint)(DateTime.Now.Ticks/1000000);
    private double min = 0, max = 1;  // Opseg realnih rezultata.

    public Uniforman(double mi, double ma, uint kl) // Konstruktori.
      { min = mi; max = ma; klica = kl; }
    public Uniforman(double mi, double ma) { min = mi; max = ma; }
    public Uniforman(uint kl) { klica = kl; }
    public Uniforman() {}

    public uint SlucBrojCeo()         // Sluajan ceo broj [0,2^31-1).
      { return klica = 314159621 * klica + 907633385; }

    public double SlucBroj()          // Sluajan realan broj [min,max).
      { return min + (max-min) * SlucBrojCeo() / 4294967296.0; }
  }
}
