// UredjvaciTest2.cs - Uporeivanje algoritama za ureivanje.

using Uredjivaci;
using Usluge;
using System;

public class UredjivaciTest2 {
  
  // Niz za objekte algoritama ureivanja.
  static IUredjivac[] metode = {
    new MetodaIzbora(),       new MetodaIzbora2(),
    new MetodaUmetanja(),     new MetodaUmetanja2(),
    new MetodaZameneSuseda(), new MetodaPodele()
  };
  
  // Ispitivani algoritmi i duine nizova.
  static int[] met = { 0,  1,  2,  3,  4,   3,   5,    5,     5},
               duz = {10, 10, 10, 10, 10, 100, 100, 1000, 10000};
  
  const int PONAV = 10,     // Broj ponavljanja.
            KLICA = 1;      // Klica generatora sluajnih brojeva.
 
  // Glavna metoda.
  static void Main() {
    for (int i=0; i<met.Length; i++) {
      IUredjivac metoda = metode[met[i]];
      int d = duz[i] * 1000;
      Console.Write("{0,-28} {1,8:d} ", metoda, d);
      Ceo[] niz = new Ceo [d];
      Random sluc = new Random(KLICA);
      long tsr = 0;
      for (int p=0; p<PONAV; p++) {
        for (int j=0; j<niz.Length; j++)
          niz[j] = new Ceo((int)(sluc.NextDouble() * 10000));
        long t1 = DateTime.Now.Ticks;   // 1 tik = 100 ns
        metoda.Uredi(niz);
        long t2 = DateTime.Now.Ticks;
        tsr += t2 - t1;
      }
      Console.Write("{0,6:f3}\n", tsr*1e-7/PONAV);
    }
  }
}
