// Vagon.cs - Klasa vagona.

using System.Text;

namespace Zeleznica {
  public class Vagon: Vozilo {
    private Niz<Teret> tereti;                    // Niz tereta.

    public Vagon(double st, int k)                // Inicijalizacija.
      : base(st) { tereti = new Niz<Teret>(k); }

    public Vagon Dodaj(Teret t)                   // Dodavanje tereta.
      { tereti.Dodaj(t); return this; }
  
    public override double UkTezina { get {       // Ukupna teina.
      double t = base.UkTezina;
      for (int i=0; i<tereti.Duzina; i++) t += tereti[i].Tezina;
      return t;
    }}

    public override double VucnaSila { get { return 0; } } // Vuna sila.

    public override string ToString() {           // Tekstualni opis.
      StringBuilder sb = new StringBuilder();
      sb.Append("V(").Append(UkTezina).Append("|");
      for (int i=0; i<tereti.Duzina; i++) {
        if (i > 0) sb.Append(",");
        sb.Append(tereti[i]);
      }
      return sb.Append(")").ToString();
    }
  }
}
