// Vekt.cs - Klasa vektora realnih brojeva.

namespace Vektor {
  public class Vekt {
    int min, max;                             // Granice indeksa.
    double[] niz;                             // Niz komponenata.
                                              // Inicijalizacija:
    public Vekt(int mi, int ma) {             // - zadati opseg,
      if (mi > ma) throw new GreVekt (GreVekt.OPSEG);
      niz = new double [(max=ma) - (min=mi) +1];
    }
  
    public Vekt(int ma): this(1, ma) {}       // - zadata gornja granica,
  
    public Vekt(): this(1,10) {}              // - podrazumevani opseg.

    public double this[int i] {               // Pristup komponenti:
      get {                                   // - dohvatanje,
        if (i<min || i>max) throw new GreVekt (GreVekt.INDEKS);
        return niz[i-min];
      }
      set {                                   // - postavljanje.
        if (i<min || i>max) throw new GreVekt (GreVekt.INDEKS);
        niz[i-min] = value;
      }
    }

    public static double skalPro(Vekt v1, Vekt v2) { // Skalarni proizvod.
      if (v1.niz.Length != v2.niz.Length) throw new GreVekt(GreVekt.DUZINA);
      double s = 0;
      for (int i=0; i<v1.niz.Length; s+=v1.niz[i]*v2.niz[i++]);
      return s;
    }

    public int MinInd { get { return min; } } // Dohvatanje najmanjeg

    public int MaxInd { get { return max; } } //   i najveeg indeksa.
  }
}
