// Vektor.cs - Klasa vektora
//               u prostoru.

namespace Pokretni {
  public class Vektor {
    private double x, y, z;                           // Komponente vektora.

    public Vektor() {}                                   // Inicijalizacija.
    public Vektor(double xx, double yy, double zz)
      { x = xx; y = yy; z = zz; }

    public double Intenzitet                             // Intenzitet.
      { get { return System.Math.Sqrt(x*x+y*y+z*z); } }

    public static Vektor operator+(Vektor v1, Vektor v2) // v1+v2, v1+=v2
      { return new Vektor(v1.x+v2.x, v1.y+v2.y, v1.z+v2.z); }
  
    public static Vektor operator*(Vektor v, double s)   // v*s, v*=s
      { return new Vektor(v.x*s, v.y*s, v.z*s); }

    public override string ToString()                    // Tekstualni opis.
      { return "(" + x + "," + y + "," + z + ")"; }
  }
}
