// Veriz.cs - Klasa verinih razlomaka.

namespace Verizni {
  public class Veriz {
    double[] a;                                    // Koeficijenti razlomka.
  
    public Veriz(int n) { a = new double [n]; }    // Inicijalizacija.
  
    public double this[int i] {                    // Pristup koeficijentu:
      get {                                        // - dohvatanje,
        if (i<0 || i>=a.Length) throw new GreVerInd(a.Length, i);
        return a[i];
      }
      set {                                        // - postavljanje.
        if (i<0 || i>=a.Length) throw new GreVerInd(a.Length, i);
        a[i] = value;
      }
    }
  
    public double Vr(double x) {                   // Vrednost razlomka.
      double s = 0;
      for (int i=a.Length-1; i>=0; i--) {
        if (x + s == 0) throw new GreVerNula();
        s = a[i] / (x + s);
      }
      return s;
    }
  
    public override string ToString() {            // Tekstualni opis.
      string s = "Veriz[";
      for (int i=0; i<a.Length; i++) {
        if (i > 0) s += ",";
        s += a[i];
      }
      return s + "]";
    }
  }
}
