// Voz.cs - Klasa vozova.

using System.Text;

namespace Zeleznica {
  public class Voz {
    Niz<Vozilo> vozila;                                // Niz vozila.

    public Voz(int k) { vozila = new Niz<Vozilo>(k); } // Inicijalizacija.
  
    public int Duzina                                  // Duina voza.
      { get { return vozila.Duzina; } }

    public bool Preopt(Vozilo v) {             // Da li bi se preopteretio?
      double teret = 0, sila = 0;
      for (int i=0; i<vozila.Duzina; i++) {
        Vozilo w = vozila[i];
        teret += w.UkTezina;
        sila  += w.VucnaSila;
      }
      return teret + v.UkTezina > sila + v.VucnaSila;
    }
  
    public Voz Dodaj(Vozilo v) {               // Dodavanje vozila.
      if (Preopt(v)) throw new GrePreopt();
      vozila.Dodaj(v);
      return this;
    }

    public override string ToString() {        // Tekstualni opis.
      StringBuilder sb = new StringBuilder();
      for (int i=0; i<vozila.Duzina; i++)
        sb.Append(vozila[i]).Append("\n");
      return sb.ToString();
    }
  }
}
