// ZbirFun.cs - Klasa zbirova funkcija.

using System.Text;

namespace Izvodi {
  public class ZbirFun: Fun {
    private Fun[] niz;                             // Niz funkcija.
    private int duz;                               // Broj popunjenih mesta.
  
    public ZbirFun(int n) { niz = new Fun [n]; }   // Inicijalizacija.

    public ZbirFun(): this(2) {}

    public ZbirFun Dodaj(Fun f) {                  // Dodavanje funkcije.
      if (duz == niz.Length) throw new GreZbirFunPun();
      niz[duz++] = f;
      return this;
    }

    public double F(double x) {                    // Raunanje vrednosti.
      double s = 0;
      for (int i=0; i<duz; s+=niz[i++].F(x));
      return s;
    }

    public Fun Izv() {                             // Stvaranje izvoda.
      ZbirFun z = new ZbirFun(niz.Length);
      for (int i=0; i<duz; z.Dodaj(niz[i++].Izv()));
      return z;
    }

    public override string ToString() {            // Tekstualni opis.
      StringBuilder sb = new StringBuilder();
      for (int i=0; i<duz; i++) {
        if (i > 0) sb.Append('+');
        sb.Append('(').Append(niz[i]).Append(')');
      }
      return sb.ToString();
    }
  }
}
