// ZbirkeTest.cs - Ispitivanje klasa zbirki.

using Zbirke;
using System;

public class ZbirkeTest {
  static void Main() {
    IZbirka[] nizZb = { new NUNiz(),   new UNiz(),
                        new NULista(), new ULista() };
    string[]  nasl  = { "NEUREDJEN NIZ", "UREDJEN NIZ",
                       "NEUREDJENA LISTA", "UREDJENA LISTA" };
    int[] niz = {6, 3, 7, 9, 2, 0, 4, 1, 8, 5, 2, 5, 3, 8, 0};
    for (int i=0; i<nizZb.Length; i++)
      radi(nasl[i], nizZb[i], niz);
  }
  
  private static void radi(string nasl, IZbirka zb, int[] niz) {
    Console.WriteLine("\n" + nasl);
    try {
      for (int i=0; i<niz.Length; zb.Dodaj(niz[i++]));
      Console.WriteLine("Napravljena zbirka: " + zb);
      
      Console.Write  ("Indeksiranjem:       ");
      for (int i=0; i<zb.Vel; i++)
        Console.Write(zb[i] + " ");
      Console.WriteLine();
      
      Console.Write  ("Iteratorom:          ");
      IIterator it = zb.Iterator();
      for (it=it.NaPocetak(); it.ImaTek; it.NaSledeci())
        Console.Write(it.Tek + " ");
      Console.WriteLine();
      
      zb[4] = 7;
      Console.WriteLine("zb[4]=7 (indeksom): " + zb);
      
      it.NaPocetak();
      for (int i=0; i<7; i++) it.NaSledeci();
      it.Tek = 3;
      Console.WriteLine("zb[7]=3  (iterom):  " + zb);
      Console.WriteLine("  tekuci:            " + it.Tek);
 
      it.BrisiTek();
      Console.WriteLine("Brisi tekuci:       " + zb);
      Console.WriteLine("  tekuci:            " + it.Tek);
      Console.WriteLine("Brisi zb[10]:       " + zb.Brisi(10));
    } catch (GreZbirka  g) { Console.WriteLine(g); }
  }
}
